<?xml version="1.0" encoding="UTF-8"?>

<!--
Pantalla para cargar la información geográfica de actualización

25-11-2015

@author hector.arias
@mb CargueInformacionGeograficaActualizacionMB
@cu CU-NP-AC-041 Realizar cargue de información geográfica

-->
<!DOCTYPE html>
<ui:composition xmlns="http://www.w3.org/1999/xhtml"
                xmlns:h="http://java.sun.com/jsf/html"
                xmlns:f="http://java.sun.com/jsf/core"
                xmlns:ui="http://java.sun.com/jsf/facelets"
                xmlns:p="http://primefaces.org/ui"
                xmlns:misc="http://java.sun.com/jsf/composite/misc"
                template="/templates/generalCU.xhtml">

    <ui:define name="title">.::Sistema Nacional Catastral::. .::Cargue información geográfica actualización::.
    </ui:define>
    <ui:define name="content">


        <h:form id="registroInformacionGeograficaForm">
            <p:messages id="msgsGS" showDetail="false" globalOnly="false"/>


            <p:fieldset id="informacionCargueGeografico">
                <legend class="legendTitle">
                    Cargue de información de Actualización al SNC
                </legend>

                <br/>

                <p:fieldset>

                    <legend>
                        <h:outputText value="Jurisdicción"
                                      styleClass="legendTitle"/>
                    </legend>

                    <p:spacer height="13" width="13"/>

                    <h:panelGrid columns="6" cellpadding="2" width="25%">
                        <h:outputLabel for="consultaPredioDepartamento"
                                       value="Departamento: " styleClass="outputLabelStyle"/>
                        <h:outputLabel value="*" styleClass="requiredLabelStyle" />
                        <h:selectOneMenu id="consultaPredioDepartamento"
                                         label="Departamento"
                                         value="#{cargueInformacionGeograficaActualizacion.departamentoSeleccionado}">
                            <f:selectItem itemLabel="Seleccionar..." itemValue=""/>
                            <f:selectItems
                                value="#{cargueInformacionGeograficaActualizacion.departamentosItemList}"/>
                            <p:ajax listener="#{cargueInformacionGeograficaActualizacion.actualizarMunicipiosListener}"
                                    update="consultaPredioMunicipio" onstart="statusDialog2.show();"
                                    oncomplete="statusDialog2.hide();"/>
                        </h:selectOneMenu>

                        <h:outputLabel for="consultaPredioMunicipio" value="Municipio: "
                                       styleClass="outputLabelStyle"/>
                        <h:outputLabel value="*" styleClass="requiredLabelStyle" />
                        <h:selectOneMenu id="consultaPredioMunicipio" label="Municipio"
                                         value="#{cargueInformacionGeograficaActualizacion.municipioSeleccionado}">
                            <f:selectItem itemLabel="Seleccionar..." itemValue=""/>
                            <f:selectItems value="#{cargueInformacionGeograficaActualizacion.municipiosItemList}"/>

                            <p:ajax event="change"
                                    update=":registroInformacionGeograficaForm, buscarBtn"/>

                        </h:selectOneMenu>

                        <h:outputLabel for="consultaVigencia" value="Vigencia: "
                                       styleClass="outputLabelStyle"/>
                        <h:outputLabel value="*" styleClass="requiredLabelStyle" />
                        <h:selectOneMenu id="consultaVigencia" label="Año"
                                         value="#{cargueInformacionGeograficaActualizacion.vigenciaSeleccionada}">
                            <f:selectItems value="#{cargueInformacionGeograficaActualizacion.vigenciasItemList}"/>

                            <p:ajax event="change"
                                    update=":registroInformacionGeograficaForm, buscarBtn"/>

                        </h:selectOneMenu>
                    </h:panelGrid>

                    <p:outputPanel layout="block" style="text-align:left">

                        <br/>

                        <p:commandButton value="Establecer" widgetVar="buscarBtn" id="buscarBtn"
                                         icon="ui-icon ui-icon-search" update=":registroInformacionGeograficaForm"
                                         action="#{cargueInformacionGeograficaActualizacion.establecerCargues}"
                                         onstart="statusDialog2.show();"
                                         onsuccess="statusDialog2.hide();"/>
                        <p:spacer height="13" width="13"/>
                    </p:outputPanel>

                    <p:spacer height="13" width="13"/>
                </p:fieldset>

                <p:spacer height="13" width="13"/>


                <p:tabView orientation="left" dynamic="true" id="tablasTB">

                    <p:tab title="Cargue Geográfico"
                           id="tabCargueGeo">

                        <p:fieldset toggleable="true"
                                    toggleSpeed="500"
                                    id="cargueBDGeografica">
                            
                            <p:outputPanel layout="block" style="text-align: right">
                                <h:graphicImage id="helpImg" url="/images/question_blue.png" />
                                <p:tooltip for="helpImg" value="SSSSSS"
                                           styleClass="noteTextStyle" style="text-align: left; font-size: 16px">

                                    Si ya se ha cargado y validado una base de datos geográfica y se <br /> 
                                    carga una nueva, se sobrescribirá la base previa y se descartarán <br /> 
                                    las validaciones realizadas.<br /> 
                                </p:tooltip>
                            </p:outputPanel>


                            <legend>
                                <h:outputText value="Cargue Base de Datos Geográfica"
                                              styleClass="legendTitle"/>
                            </legend>

                            <br/>

                            <h:panelGrid columns="2" width="40%">
                                <h:outputText style="font-size:16px;"
                                              styleClass="legendTitle"
                                              value="¿La base de datos geográfica incluye zonas?"/>

                                <p:selectOneRadio id="options" value="#{cargueInformacionGeograficaActualizacion.cargueZonal}"
                                                  disabled="#{!cargueInformacionGeograficaActualizacion.permitirCargue}">
                                    <f:selectItem itemValue="SI" itemLabel="SI"/>
                                    <f:selectItem itemValue="NO" itemLabel="NO"/>

                                    <p:ajax process="@this"  
                                            event="change"
                                            oncomplete="confirmaCambioValidacionWV.show()"
                                            update=":registroInformacionGeograficaForm"
                                            listener="#{cargueInformacionGeograficaActualizacion.listenerCargueZonal}"/>

                                </p:selectOneRadio>
                            </h:panelGrid>

                            <p:spacer height="20" width="13"/>

                            <h:panelGrid cellpadding="2" columns="2" width="100%">
                                <h:panelGrid id="carguePredial" cellpadding="2" width="100%">

                                    <h:outputText style="font-size:16px;"
                                                  value="Seleccione la base de datos geográfica predial."/>

                                    <br/>

                                    <h:panelGrid cellpadding="2" columns="2" width="100%">
                                        <p:commandButton value="Cargue base geográfica predial"
                                                         icon="ui-icon-check"
                                                         disabled="#{!cargueInformacionGeograficaActualizacion.permitirCargue}"
                                                         action="#{cargueInformacionGeograficaActualizacion.cargarOpcionPredios}"
                                                         onstart="statusDialog2.show();"
                                                         onsuccess="statusDialog2.hide(); cargarArchivosWV.show();"
                                                         update="validacionesGeograficas, :sobrescribirCargueForm, :registroInformacionGeograficaForm, :cargarArchivosForm"/>



                                        <p:commandButton value="Cargue BD mediante conexión"
                                                         icon="ui-icon-arrowstop-1-n"
                                                         disabled="true"
                                                         action="#{cargueInformacionGeograficaActualizacion.cargarOpcionesCargaTablas}"/>
                                    </h:panelGrid>

                                    <br/>

                                    <h:panelGrid cellpadding="2" columns="2" width="40%">
                                        <h:outputText style="font-size:16px;"
                                                      styleClass="legendTitle"
                                                      value="Fecha de último cargue exitoso BD predial:" />

                                        <h:outputText style="font-size:16px;"
                                                      value="#{cargueInformacionGeograficaActualizacion.ultimoCargue}"/>

                                    </h:panelGrid>

                                    <br/>


                                    <h:panelGrid cellpadding="2" columns="2" width="50%">
                                        <h:outputText style="font-size:16px;"
                                                          styleClass="legendTitle"
                                                          value="Archivo:"/>
                                            <h:outputText style="font-size:16px;"
                                                          value="#{cargueInformacionGeograficaActualizacion.nombreArchivoCargadoPredial}"/>

                                            <h:outputText style="font-size:16px;"
                                                          styleClass="legendTitle"
                                                          value="Estado:"/>
                                            <h:outputText style="font-size:16px;"
                                                          value="#{cargueInformacionGeograficaActualizacion.estadoArchivoCargadoPredial}"/>
                                    </h:panelGrid>
                                </h:panelGrid>

                                <h:panelGrid id="cargueZonal" cellpadding="2" width="100%" rendered="#{!cargueInformacionGeograficaActualizacion.banderaCargueZonal}">

                                    <h:outputText style="font-size:16px;"
                                                  value="Seleccione la base de datos geográfica zonal."/>

                                    <br/>

                                    <h:panelGrid cellpadding="2" columns="2" width="100%">
                                        <p:commandButton value="Cargue base zonas"
                                                         icon="ui-icon-check"
                                                         disabled="#{!cargueInformacionGeograficaActualizacion.permitirCargue}"
                                                         action="#{cargueInformacionGeograficaActualizacion.cargarOpcionZonas}"
                                                         onstart="statusDialog2.show();"
                                                         onsuccess="statusDialog2.hide(); cargarArchivosWV.show();"
                                                         update="validacionesGeograficas,:sobrescribirCargueForm"/>

                                        <p:commandButton value="Cargue BD mediante conexión"
                                                         icon="ui-icon-arrowstop-1-n"
                                                         disabled="true"
                                                         action="#{cargueInformacionGeograficaActualizacion.cargarOpcionesCargaTablas}"/>
                                    </h:panelGrid>

                                    <br/>

                                    <h:panelGrid cellpadding="2" columns="2" width="40%">
                                        <h:outputText style="font-size:16px;"
                                                      styleClass="legendTitle"
                                                      value="Fecha de último cargue exitoso BD zonal:" />

                                        <h:outputText style="font-size:16px;"
                                                      value="#{cargueInformacionGeograficaActualizacion.ultimoCargue}"/>

                                    </h:panelGrid>

                                    <br/>

                                    <h:panelGrid cellpadding="2" columns="4" width="50%">
                                        <h:panelGrid cellpadding="2" columns="2" width="100%">
                                            <h:outputText style="font-size:16px;"
                                                          styleClass="legendTitle"
                                                          value="Archivo:"/>
                                            <h:outputText style="font-size:16px;"
                                                          value="#{cargueInformacionGeograficaActualizacion.nombreArchivoCargadoZonal}"/>

                                            <h:outputText style="font-size:16px;"
                                                          styleClass="legendTitle"
                                                          value="Estado:"/>
                                            <h:outputText style="font-size:16px;"
                                                          value="#{cargueInformacionGeograficaActualizacion.estadoArchivoCargadoZonal}"/>
                                        </h:panelGrid>
                                    </h:panelGrid>
                                </h:panelGrid>
                            </h:panelGrid>

                        </p:fieldset>

                        <p:spacer height="15" width="13"/>

                        <p:fieldset id="validacionesGeograficas">
                            <h:panelGrid width="50%">
                                <legend>
                                    <h:outputText value="Validaciones geográficas"
                                                  styleClass="legendTitle"/>
                                </legend>
                                
                                <p:outputPanel layout="block" style="text-align: right">
                                    <h:graphicImage id="helpImg2" url="/images/question_blue.png" />
                                    <p:tooltip for="helpImg2" value="SSSSSS"
                                               styleClass="noteTextStyle" style="text-align: left; font-size: 16px">

                                        Se realizarán las validaciones correspondientes a las base de datos <br /> 
                                        geográficas cargadas. Si alguna de las dos no existe, no se realizará <br /> 
                                        la validación respectiva.<br /> 
                                    </p:tooltip>
                                </p:outputPanel>

                                <br/>
                                
                                <h:panelGrid cellpadding="2" columns="2">

                                    <p:commandButton value="Validar"
                                                     icon="ui-icon-check"
                                                     update=":registroInformacionGeograficaForm"
                                                     onstart="statusDialog2.show();" onsuccess="statusDialog2.hide();"
                                                     disabled="#{!cargueInformacionGeograficaActualizacion.habilitarValidacion}"
                                                     action="#{cargueInformacionGeograficaActualizacion.consultarValidacionEncurso}"/>

                                    <p:commandButton value="Refrescar"
                                                     icon="ui-icon-arrowrefresh-1-n"
                                                     onstart="statusDialog2.show();" onsuccess="statusDialog2.hide();"
                                                     update=":registroInformacionGeograficaForm"
                                                     action="#{cargueInformacionGeograficaActualizacion.listenerEstadoValidacionActualizacion}"
                                                     disabled="false"/>
                                    <br/>
                                </h:panelGrid>

                                <h:panelGrid cellpadding="2" columns="2">
                                    <h:outputText style="font-size:16px;"
                                                  value="Estado validación:"/>
                                    <h:outputText style="font-size:16px;"
                                                  value="#{cargueInformacionGeograficaActualizacion.estadoValidacionActualizacion}"/>
                                </h:panelGrid>

                                <br/>

                                <p:outputPanel>
                                    <p:dataTable id="validacionActualizacionDT"
                                                 value=""
                                                 var="rutaArchivoInconsistencias"
                                                 paginator="true" rows="10" rowKey=""
                                                 paginatorTemplate="{RowsPerPageDropdown} {FirstPageLink} {PreviousPageLink} {PageLinks} {CurrentPageReport} {NextPageLink} {LastPageLink}"
                                                 rowsPerPageTemplate="5,10,15" paginatorPosition="bottom"

                                                 emptyMessage="No se encontraron procesos activos.">

                                        <p:column headerText="Validación">
                                            <h:outputText value="#{cargueInformacionGeograficaActualizacion.nombreValidacion}"
                                                          styleClass="outputTextStyleInTable"/>
                                        </p:column>
                                        <p:column headerText="Estado">
                                            <h:outputText style="font-size:16px;"
                                                  value="#{cargueInformacionGeograficaActualizacion.estadoValidacionActualizacion}"/>
                                        </p:column>
                                        <p:column headerText="Opciones">
                                            <h:outputText value=""
                                                          styleClass="outputTextStyleInTable"/>
                                            
                                            <p:commandButton value="Descargar" id="descargarBtn" ajax="false"
                                                             icon="ui-icon-print" immediate="true"
                                                             rendered="#{cargueInformacionGeograficaActualizacion.habilitarDescarga}">
                                                <p:fileDownload value="#{cargueInformacionGeograficaActualizacion.rutaArchivoInconsistencias.streamedContentReporte}" />
                                            </p:commandButton>
                                            
                                        </p:column>

                                    </p:dataTable>
                                </p:outputPanel>
                            </h:panelGrid>
                        </p:fieldset>
                    </p:tab>
                </p:tabView>
            </p:fieldset>


            <p:spacer height="20" width="13"/>


            <p:outputPanel layout="block" style="text-align:right">

                <p:spacer height="40" width="13"/>
                <p:commandButton value="Cerrar"
                                 icon="ui-icon-circle-close"
                                 action="#{cargueInformacionGeograficaActualizacion.cerrar}"
                                 onstart="statusDialog2.show();" onsuccess="statusDialog2.hide();"
                                 immediate="true" process="@this" ajax="false"/>
                <p:spacer height="0" width="20"/>

            </p:outputPanel>
            <p:spacer height="40" width="13"/>

        </h:form>

        <p:dialog header="Cargar archivos" dynamic="true"
                  widgetVar="cargarArchivosWV" modal="true" appendToBody="true"
                  resizable="true" position="center" width="650" height="150">
            <h:form id="cargarArchivosForm">

                <p:spacer height="10" width="13"/>
                <p:messages id="cargarArchivosMsgs"/>
                <p:spacer height="10" width="13"/>

                <h:outputText value="#{cargueInformacionGeograficaActualizacion.baseDeDatosExistente}"
                                  styleClass="outputTextStyleInTable"/>

                <h:panelGrid columns="2" cellpadding="10" width="100%">
                    
                    

                    <p:fileUpload id="fu" label="Cargar documento" style="width: 500px;"
                                  fileUploadListener="#{cargueInformacionGeograficaActualizacion.archivoUpload}"
                                  immediate="true"
                                  dragDropSupport="true"
                                  invalidFileMessage="El archivo no tiene el formato permitido. Por favor verifique"
                                  invalidSizeMessage="El archivo seleccionado supera el tamaño permitido"
                                  widgetVar="uploader" mode="advanced" auto="true"
                                  allowTypes="/(\.|\/)(7z)$/"
                                  update="fu, :cargarArchivosForm"
                                  onstart="statusDialog2.show();"
                                  oncomplete="statusDialog2.hide();"/>

                </h:panelGrid>


                <p:outputPanel layout="block" style="text-align:center">
                    <p:commandButton value="Guardar"
                                     disabled="#{!cargueInformacionGeograficaActualizacion.banderaArchivoCargado}"
                                     update="cargarArchivosMsgs, :cargarArchivosForm, :registroInformacionGeograficaForm"
                                     action="#{cargueInformacionGeograficaActualizacion.procesarCargue}"
                                     onstart="statusDialog2.show();"
                                     oncomplete="showAlternativeDialog(args, cargarArchivosWV);statusDialog2.hide(); cargarArchivosWV.hide();"
                                     icon="ui-icon-check"/>
                    <p:spacer width="10"/>
                    <p:commandButton value="Cancelar" icon="ui-icon-close"
                                     onclick="cargarArchivosWV.hide();"/>
                </p:outputPanel>
                <p:spacer height="20" width="13"/>
            </h:form>
        </p:dialog>
        
        <p:dialog header="Confirmación de sobrescritura de BD" dynamic="true"
                  widgetVar="sobrescribirCargueMV" modal="true" appendToBody="true"
                  resizable="true" position="center" width="550" height="400">
            <h:form id="sobrescribirCargueForm">

                <p:spacer height="10" width="13"/>
                <p:messages id="devolverPrediosMsgs"/>
                <p:spacer height="10" width="13"/>

            <p:fieldset>


            <h:panelGrid columns="1" cellpadding="10">

                    <div style="font-size:14px; text-align:justify;">
                        ¿Está seguro que desea sobrescribir la BD cargada?
                        Si se han obtenido resultados de las validaciones, éstos
                        serán eliminados.
                        <br/>
                    </div>
                </h:panelGrid>
            </p:fieldset>

                <p:outputPanel layout="block" style="text-align:center; margin-top:10px;">
                    <p:commandButton value="Aceptar"
                                     update=":registroInformacionGeograficaForm"
                                     action="#{cargueInformacionGeograficaActualizacion.cargarOpcionPredios}"
                                     onstart="statusDialog2.show(); cargarArchivosWV"
                                     oncomplete="sobrescribirCargueMV.hide(); statusDialog2.hide();"
                                     icon="ui-icon-check"/>
                    <p:spacer width="10"/>
                    <p:commandButton value="Rechazar" icon="ui-icon-close"
                                     onclick="sobrescribirCargueMV.hide();"/>
                </p:outputPanel>

                <p:spacer height="20" width="13"/>
            </h:form>
        </p:dialog>
        
                
         <p:dialog 
                  widgetVar="confirmaCambioValidacionWV" modal="true" dynamic="true"
                  appendToBody="true" resizable="true" position="center" height="80"
                  width="600">
            <h:form id="confirmarCambioValidacion">
                <h:panelGrid columns="2" cellspacing="3">
                    <h:outputLabel
                        value="¿Está seguro que desea modificar lo establecido sobre la inclusión de la información de zonas en la base geográfica a cargar?
                        Se eliminará toda información cargada y validada previamente."
                        styleClass="outputLabelStyle" />
                </h:panelGrid>
                <p:panel>
                    <p:spacer width="200" height="0" />
                    <p:commandButton value="Aceptar" icon="ui-icon-check"
                                     title="Aceptar" oncomplete="confirmaCambioValidacionWV.hide()" 
                                     update=":registroInformacionGeograficaForm"/>
                </p:panel>
            </h:form>
        </p:dialog>
        
        <misc:ultimateConfirmDialogCC
            confirmMessage="¿Está seguro que desea reiniciar el proceso de validación? 
            Si se estan realizando validaciones sobre la BD, éstas serán reiniciadas. 
            Los resultados obtenidos de las validaciones previas serán eliminados."
            confirmDialogWV="reinicarValidacionWV"
            confirmUpdateOnYes=":registroInformacionGeograficaForm" 
            voidActionOnYes="#{cargueInformacionGeograficaActualizacion.validacionGeografica}"
            voidActionOnNo="#{cargueInformacionGeograficaActualizacion.reinicarValidacionFalse}"
            actionOnNoIsClose="true"
            yesLabel="Aceptar" noLabel="Cancelar" 
            width="600"/>
        
        <misc:ultimateConfirmDialogCC
            confirmMessage="Al cambiar la información de la jurisdicción establecida inicialmente, se cancelará el cargue en curso. ¿Desea cambiar la jurisdicción establecida?"
            confirmDialogWV="cambioJurisdiccionWV"
            confirmUpdateOnYes=":registroInformacionGeograficaForm" 
            voidActionOnYes="#{cargueInformacionGeograficaActualizacion.validacionGeografica}"
            voidActionOnNo="#{cargueInformacionGeograficaActualizacion.reinicarValidacionFalse}"
            actionOnNoIsClose="true"
            yesLabel="Aceptar" noLabel="Cancelar" 
            width="600"/>
        
    </ui:define>
</ui:composition>